package lightcontainer.domains.client;

import lightcontainer.storage.AppData;
import lightcontainer.storage.User;
import lightcontainer.utils.AES_GCM;

import java.security.NoSuchAlgorithmException;
import java.util.LinkedList;

public class Context {

    private AppData appData;

    /**
     * Login de l'utilisateur
     */
    private String login;


    public Context(AppData appData) {
        this.appData = appData;
    }


    public boolean createUser(String login, String password) {
        try {
            String key = AES_GCM.generateSecretKey();
            if (this.appData.addUser(login, password, key)) {
                this.login = login;
                return true;
            }
        } catch (AES_GCM.AesGcmException e) {}
        return false;
    }

    /**
     * Login de l'utilisateur
     * @return Login de l'utilisateur
     */
    public String getLogin() {
        return this.login;
    }


    /**
     * Permet de demander la connection de l'utilisateur
     * @param login Login
     * @param password Mot de passe
     * @return TRUE si l'utilisateur a été authentifié
     */
    public boolean signIn(String login, String password) {
        if (login.equals("aaaaa") && password.equals("aaaaa")) {
            this.login = login;
            return true;
        }
        return false;
    }

    /**
     * Permet de savoir si l'utilisateur s'est connecté (Avec login et mdp)
     * @return TRUE si l'utilisateur est connecté
     */
    public boolean isConnected() {
        return this.getLogin() != null;
    }
}
