package lightcontainer.protocol.rules.reader;

import lightcontainer.domains.client.Context;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.protocol.rules.writer.FilesRule;
import lightcontainer.protocol.rules.writer.SignOkRule;

public class FilelistRule extends ProtocolReader {
    // Constants
    private static final String PATTERN = "^FILELIST\r\n$";

    private static final String NAME = "FILELIST";

    private ProtocolRepository protocolRep;

    // Constructor
    public FilelistRule(ProtocolRepository protocolRep) {
        super(NAME, PATTERN);
        this.protocolRep = protocolRep;
    }

    public class Result extends ProtocolResult {
        public Result(Context context) {
            super(context);
        }
    }

    /**
     * Cette méthode est appelée lors de l'exécution de la règle
     * @param data Paramètres pour créer la commande.
     */
    @Override
    protected FilelistRule.Result onExecuted(Context context, String... data) {
        FilelistRule.Result result = new Result(context);
        result.setResultCommand(this.protocolRep.executeWriter(FilesRule.NAME, "endbenja.txt!500"), ResultCmdReceiver.CLIENT);
        return result;
    }
}
