package lightcontainer.protocol.rules.reader;

import lightcontainer.domains.client.Context;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.ProtocolWriter;
import lightcontainer.protocol.rules.writer.SaveFileOkRule;

public class SendOkRule extends ProtocolReader {


    // Constants
    private static final String PATTERN = "^SEND_OK\r\n$";

    private static final String NAME = "SEND_OK";

    private ProtocolRepository protocolRep;

    // Constructor
    public SendOkRule(ProtocolRepository protocolRep) {
        super(NAME, PATTERN);
        this.protocolRep = protocolRep;
    }


    @Override
    protected ProtocolReader.ProtocolResult onExecuted(Context context, String... data) {
        ProtocolReader.ProtocolResult result = new ProtocolReader.ProtocolResult(context);
        result.setResultCommand(protocolRep.executeWriter(SaveFileOkRule.NAME), ResultCmdReceiver.CLIENT);
        return result;
    }
}
